/*
 * enums.cpp
 *
 *  Created on: May 23, 2014
 *      Author: daniel
 */

#include "op_exceptions.h"
#include "enums.h"

using namespace CuTe::NS_enums::NS_BFUNCS;
using namespace CuTe::NS_enums::NS_COL;
using namespace CuTe::NS_enums::NS_CUBA;
using namespace CuTe::NS_enums::NS_MS;
using namespace CuTe::NS_enums::NS_MU_OPS;
using namespace CuTe::NS_enums::NS_NP;
using namespace CuTe::NS_enums::NS_PROD;
using namespace CuTe::NS_enums::NS_RES;
using namespace CuTe::NS_enums::NS_RESULTS;
using namespace CuTe::NS_enums::NS_TD_PARTON;
using namespace CuTe::NS_enums::NS_Partons;

using NS_OPTIONS::bad_in_exception;

using std::istream;
using std::ostream;
using std::string;


//std::ostream& CuTe::NS_enums::NS_Stepfunction::operator<<( std::ostream& os, const ENUM_Stepfunction_Type type){
//	switch (type) {
//		case SFT_Erf:
//			os << "Erf";
//			break;
//		case SFT_Logistic:
//			os << "Logistic";
//			break;
//		case SFT_Gompertz:
//			os << "Gompertz";
//			break;
//		case SFT_No:
//			os << "NO";
//			break;
//		case SFT_ETA:
//			os << "ETA";
//			break;
//		default:
//			os << "WRONG";
//			break;
//	}
//	return os;
//}

//std::istream& CuTe::NS_enums::NS_Stepfunction::operator>>(std::istream &is, ENUM_Stepfunction_Type &type){
//	string tmp;
//	is >> tmp;
//	type	= SFT_WRONG;
//	if(tmp=="Erf")		type = SFT_Erf;
//	if(tmp=="Logistic")	type = SFT_Logistic;
//	if(tmp=="Gompertz")	type = SFT_Gompertz;
//	if(tmp=="No")		type = SFT_No;
//	if(tmp=="NO")		type = SFT_No;
//	if(tmp=="ETA")		type = SFT_ETA;
//	if(type==SFT_WRONG) throw bad_in_exception(tmp);
//	return is;
//}

ostream& CuTe::NS_enums::NS_BFUNCS::operator<<(ostream& os, const ENUM_B_FUNCS B){
	switch (B) {
	case E_BFUNC_Bbar:
		os << "Bbar";
		break;
	case E_BFUNC_B:
		os << "B";
		break;
	case E_BFUNC_FB:
		os << "FB";
		break;
//	case E_BFUNC_BbarTilde:
//		os << "TildeBbar";
//		break;
//	case E_BFUNC_FBTilde:
//		os << "TildeFB";
//		break;
//	case E_BFUNC_BTilde:
//		os << "TildeB";
//		break;
	default:
		os << "WRONG";
		break;
	}
	return os;
}

ostream& CuTe::NS_enums::NS_PC::operator<<(ostream& os, const POWER_COUNTING pc){
	switch (pc) {
	case PC_NAIVE:
		os << "NAIVE";
		break;
	case PC_STD:
		os << "STANDARD";
		break;
	case PC_IMP:
		os << "IMPROVED";
		break;
	case PC_NO_RES:
		os << "NO_RESUMMATION";
		break;
	default:
		os << "WRONG";
		break;
	}
	return os;
}

ostream& CuTe::NS_enums::NS_PROD::operator<<(ostream& os, const PROD prod){
	switch (prod) {
		case PROD_DY:
			os << "DY";
			break;
		case PROD_Z:
			os << "Z";
			break;
		case PROD_W:
			os << "W";
			break;
		case PROD_Higgs:
			os << "H";
			break;
		case PROD_H_RS:
			os << "H_RS";
			break;
		default:
			os << "WRONG";
			break;
	}
	return os;
}

//ostream& CuTe::NS_enums::operator<<(ostream& os, const const LHA_ERROR_TYPE et){
//	switch (et) {
//		case LHA_ERR_replicas:
//			os << "replicas";
//			break;
//		case LHA_ERR_symmhessian:
//			os << "symmhessian";
//			break;
//		case LHA_ERR_hessian:
//			os << "hessian";
//			break;
//		case LHA_ERR_none:
//			os << "none";
//			break;
//		case LHA_ERR_UNKNOWN:
//			os << "UNKNOWN";
//			break;
//		case LHA_ERR_custom:
//			os << "custom";
//			break;
//		default:
//			os << "WRONG";
//			break;
//	}
//	return os;
//}


ostream& CuTe::NS_enums::NS_MS::operator<<(ostream& os,MS ms){
	switch (ms) {
		case MS_NAIVE:
			os << "NAIVE";
			break;
		case MS_CONST_MU:
			os << "CONST_MU";
			break;
		case MS_CONST_QT:
			os << "CONST_QT";
			break;
		case MS_VAR_MU:
			os << "MU";
			break;
		case MS_VAR_QT:
			os << "QT";
			break;
		case MS_CONST_MU_PI2:
			os << "CONST_MU_PI2";
			break;
		case MS_CONST_QT_PI2:
			os << "CONST_QT_PI2";
			break;
		case MS_VAR_MU_PI2:
			os << "VAR_MU_PI2";
			break;
		case MS_VAR_QT_PI2:
			os << "VAR_QT_PI2";
			break;
		default:
			os << "WRONG";
			break;
	}
	return os;
}

ostream& CuTe::NS_enums::NS_COL::operator<<(ostream& os,COL col){
	switch (col) {
		case COL_PP:
			os << "PP";
			break;
		case COL_PbarP:
			os << "PPbar";
			break;
		case COL_PbarPbar:
			os << "PbarPbar";
			break;
		default:
			os << "WRONG";
			break;
	}
	return os;
}

ostream& CuTe::NS_enums::NS_RES::operator<<(ostream& os,RES res){
	switch (res) {
		case RES_LO:
			os <<  "FO";
			break;
		case RES_LL:
			os <<  "RES";
			break;
		case RES_LLO:
			os <<  "SQT";
			break;
		case RES_MATCHED:
			os <<  "MATCHED";
			break;
		case RES_MATCHING_CORR:
			os <<  "MC";
			break;
		case RES_RES_CORR:
			os <<  "RC";
			break;
		default:
			os <<  "WRONG";
			break;
	}
	return os;
}


const std::string CuTe::NS_enums::NS_RES::long_str(const RES res){
	string os;
	switch (res) {
		case RES_LO:
			os =  "fixed-order";
			break;
		case RES_LL:
			os =  "resummed";
			break;
		case RES_LLO:
			os =  "small-qT";
			break;
		case RES_MATCHED:
			os =  "matched";
			break;
		case RES_MATCHING_CORR:
			os =  "matching-correction";
			break;
		case RES_RES_CORR:
			os =  "resummation-correction";
			break;
		default:
			os =  "WRONG";
			break;
	}
	return os;
}


//ostream& CuTe::NS_enums::operator<<(ostream& os,PDF_ERR err){
//	switch (err) {
//		case PDF_ERR_NO:
//			os <<   "NO";
//			break;
//		case PDF_ERR_HESSIAN:
//			os <<   "HESSIAN";
//			break;
//		case PDF_ERR_GAUSSIAN:
//			os <<   "GAUSSIAN";
//			break;
//		default:
//			os <<   "WRONG";
//			break;
//	}
//	return os;
//}

ostream& CuTe::NS_enums::NS_NP::operator<<(ostream& os,CUTOFF cutoff){
	switch (cutoff) {
		case CUTOFF_NO:
			os << "NO";
			break;
		case CUTOFF_GAUSS:
			os << "GAUSS";
			break;
		case CUTOFF_HARD:
			os << "HARD";
			break;
		case CUTOFF_DIPOL:
			os << "DIPOLE";
			break;
		case CUTOFF_ENHANCED:
			os << "ENHANCED";
			break;
		default:
			os << "WRONG";
			break;
	}
	return os;
}
ostream& CuTe::NS_enums::NS_CUBA::operator<<( ostream& os, const CUBA_R cr){
	switch (cr) {
		case CUBA_R_VEGAS:
			os << "VEGAS";
			break;
		case CUBA_R_SUAVE:
			os << "SUAVE";
			break;
		case CUBA_R_DIVONNE:
			os << "DIVONNE";
			break;
		case CUBA_R_CUHRE:
			os << "CUHRE";
			break;
		default:
			os << "WRONG";
			break;
	}
	return os;
}
ostream& CuTe::NS_enums::NS_MU_OPS::operator<<( ostream& os, const ENUM_MU_CONST_OPTION mu){
	switch (mu) {
		case ENUM_MU_M:
			os << "M";
			break;
		case ENUM_MU_QT:
			os << "QT";
			break;
		case ENUM_MU_MU_STAR:
			os << "MU*";
			break;
		case ENUM_MU_QSV:
			os << "q*V";
			break;
		case ENUM_MU_QSS:
			os << "q*S";
			break;
		case ENUM_MU_LP0:
			os << "LP0";
			break;
		case ENUM_MU_B0:
			os << "b0";
			break;
		default:
			os << "WRONG";
			break;
	}
	return os;
}
std::ostream& CuTe::NS_enums::NS_RESULTS::operator<<(std::ostream &os, const E_RESULTS R){
	using namespace NS_enums::NS_RES;
	switch (R) {
	case ER_qT:
		os	<<"qT";
		break;
	case ER_mu:
		os	<<"mu";
		break;
	case  ER_y:
		os	<<"y";
		break;
	case ER_erg_result:
		os	<<"result";
		break;
	case ER_erg_RES:
		os	<<RES_LL;
		break;
	case  ER_erg_FO:
		os	<<RES_LO;
		break;
	case  ER_erg_SQT:
		os	<<RES_LLO;
		break;
	case  ER_erg_MC:
		os	<<RES_MATCHING_CORR;
		break;
	case  ER_erg_RC:
		os	<<RES_RES_CORR;
		break;
	case ER_erg_Delta:
		os	<<"D_int";
		break;
	case ER_erg_mu_P:
		os	<<"D_mu+";
		break;
	case ER_erg_mu_M:
		os	<<"D_mu-";
		break;
	case ER_erg_PDF_Delta:
		os	<<"D_PDF";
		break;
	case ER_erg_PDF_DeltaP:
		os	<<"D_PDF+";
		break;
	case ER_erg_PDF_DeltaM:
		os	<<"D_PDF-";
		break;
	case ER_erg_PDF_Scale:
		os	<<"D_PDF_scale";
		break;
	case ER_erg_exp:
		os	<<"D_exp+-";
		break;
	case ER_erg_DCP	:
		os	<<"D_C+";
		break;
	case ER_erg_DCM:
		os	<<"D_C-";
		break;
	default:
		os	<<"WRONG";
		break;
	}
	return os;
}

const std::string CuTe::NS_enums::NS_RESULTS::long_str(const E_RESULTS R){
	string os;
	using namespace NS_enums::NS_RES;
	switch (R) {
	case ER_erg_RES:
		os	= NS_enums::NS_RES::long_str(RES_LL);
		break;
	case  ER_erg_FO:
		os	= long_str(RES_LO);
		break;
	case  ER_erg_SQT:
		os	= long_str(RES_LLO);
		break;
	case  ER_erg_MC:
		os	= long_str(RES_MATCHING_CORR);
		break;
	case  ER_erg_RC:
		os	= long_str(RES_RES_CORR);
		break;
	default:
		std::stringstream ss;
		ss << R;
		os	=ss.str();
		break;
	}
	return os;
}

istream& CuTe::NS_enums::NS_RESULTS::operator>>(istream &is, E_RESULTS &e_R){
	string tmp;
	is >> tmp;
	e_R	= ER_Last;
	if(tmp=="qT")			e_R = ER_qT;
	if(tmp=="mu")			e_R = ER_mu;
	if(tmp=="y")			e_R = ER_y;
	if(tmp=="result")		e_R = ER_erg_result;
	if(tmp=="RES")			e_R = ER_erg_RES;
	if(tmp=="FO")			e_R = ER_erg_FO;
	if(tmp=="SQT")			e_R = ER_erg_SQT;
	if(tmp=="MC")			e_R = ER_erg_MC;
	if(tmp=="RC")			e_R = ER_erg_RC;
	if(tmp=="D_int")		e_R = ER_erg_Delta;
	if(tmp=="D_mu+")		e_R = ER_erg_mu_P;
	if(tmp=="D_mu-")		e_R = ER_erg_mu_M;
	if(tmp=="D_PDF")		e_R = ER_erg_PDF_Delta;
	if(tmp=="D_PDF+")		e_R = ER_erg_PDF_DeltaP;
	if(tmp=="D_PDF-")		e_R = ER_erg_PDF_DeltaM;
	if(tmp=="D_PDF_scale")	e_R = ER_erg_PDF_Scale;
	if(tmp=="D_exp+-")		e_R = ER_erg_exp;
	if(tmp=="D_C+")			e_R = ER_erg_DCP;
	if(tmp=="D_C-")			e_R = ER_erg_DCM;
	if(e_R==ER_Last) throw bad_in_exception(tmp);
	return is;
}
std::ostream& CuTe::NS_enums::NS_TD_PARTON::operator<<(std::ostream &os, const ENUM_TDPDF_Parton e_B){
	switch (e_B) {
	case e_B_t_bar:
		os	<<"bar(t)";
		break;
	case e_B_b_bar:
		os	<<"bar(b)";
		break;
	case e_B_c_bar:
		os	<<"bar(c)";
		break;
	case e_B_s_bar:
		os	<<"bar(s)";
		break;
	case e_B_u_bar:
		os	<<"bar(u)";
		break;
	case e_B_d_bar:
		os	<<"bar(d)";
		break;
	case e_B_G:
		os	<<"G";
		break;
	case e_B_d:
		os	<<"d";
		break;
	case e_B_u:
		os	<<"u";
		break;
	case e_B_s:
		os	<<"s";
		break;
	case e_B_c:
		os	<<"c";
		break;
	case e_B_b:
		os	<<"b";
		break;
	case e_B_t:
		os	<<"t";
		break;
	case e_B_G1:
		os	<<"G1";
		break;
	case e_B_G2:
		os	<<"G2";
		break;
	default:
		os	<<"WRONG";
		break;
	}
	return os;
}
istream& CuTe::NS_enums::NS_TD_PARTON::operator>>(istream &is, ENUM_TDPDF_Parton &e_B){
	string tmp;
	is >> tmp;
	e_B	= ENUM_TDPDF_Parton_WRONG;
	if(tmp=="bar(t)")	e_B = e_B_t_bar;
	if(tmp=="bar(b)")	e_B = e_B_b_bar;
	if(tmp=="bar(c)")	e_B = e_B_c_bar;
	if(tmp=="bar(s)")	e_B = e_B_s_bar;
	if(tmp=="bar(u)")	e_B = e_B_u_bar;
	if(tmp=="bar(d)")	e_B = e_B_d_bar;
	if(tmp=="G")		e_B = e_B_G;
	if(tmp=="d")		e_B = e_B_d;
	if(tmp=="u")		e_B = e_B_u;
	if(tmp=="s")		e_B = e_B_s;
	if(tmp=="c")		e_B = e_B_c;
	if(tmp=="b")		e_B = e_B_b;
	if(tmp=="t")		e_B = e_B_t;
	if(tmp=="G1")		e_B = e_B_G1;
	if(tmp=="G2")		e_B = e_B_G2;
	if(e_B==ENUM_TDPDF_Parton_WRONG) throw bad_in_exception(tmp);
	return is;
}
istream& CuTe::NS_enums::NS_PC::operator>>(istream &is, POWER_COUNTING &pc){
	string tmp;
	is >> tmp;
	pc	= PC_WRONG;
	if(tmp=="NAIVE")			pc = PC_NAIVE;
	if(tmp=="IMPROVED")			pc = PC_IMP;
	if(tmp=="STANDARD")			pc = PC_STD;
	if(tmp=="NO_RESUMMATION")	pc = PC_NO_RES;
	if(pc==PC_WRONG) throw bad_in_exception(tmp);
	return is;
}

istream& CuTe::NS_enums::NS_MU_OPS::operator>>( istream& is, ENUM_MU_CONST_OPTION& mu ){
	string tmp;
	is >> tmp;
	mu	= ENUM_MU_WRONG;
	if(tmp=="M")	mu	= ENUM_MU_M;
	if(tmp=="QT")	mu	= ENUM_MU_QT;
	if(tmp=="MU*")	mu	= ENUM_MU_MU_STAR;
	if(tmp=="q*V")	mu	= ENUM_MU_QSV;
	if(tmp=="q*Z")	mu	= ENUM_MU_QSV;
	if(tmp=="q*W")	mu	= ENUM_MU_QSV;
	if(tmp=="q*S")	mu	= ENUM_MU_QSS;
	if(tmp=="LP0")	mu	= ENUM_MU_LP0;
	if(tmp=="b0")	mu	= ENUM_MU_B0;
	if(mu==ENUM_MU_WRONG) throw bad_in_exception(tmp);
	return is;
}

istream& CuTe::NS_enums::NS_BFUNCS::operator>>( istream& is, ENUM_B_FUNCS& B ){
	string tmp;
	is >> tmp;
	B =	E_BFUNC_WRONG;
	if(tmp=="Bbar")			B =	E_BFUNC_Bbar;
	if(tmp=="B")			B =	E_BFUNC_B;
	if(tmp=="FB")			B =	E_BFUNC_FB;
//	if(tmp=="TildeBbar")	B =	E_BFUNC_BbarTilde;
//	if(tmp=="TildeFB")		B =	E_BFUNC_FBTilde;
//	if(tmp=="TildeB")		B =	E_BFUNC_BTilde;
	if(B==E_BFUNC_WRONG) throw bad_in_exception(tmp);
	return is;
}

istream& CuTe::NS_enums::NS_MS::operator>>( istream& is, MS& ms ){
	string tmp;
	is >> tmp;
	ms =	MS_WRONG;
	if(tmp=="NAIVE")		ms =	MS_NAIVE;
	if(tmp=="CONST_MU")		ms =	MS_CONST_MU;
	if(tmp=="CONST_QT")		ms =	MS_CONST_QT;
	if(tmp=="VAR_MU")		ms =	MS_VAR_MU;
	if(tmp=="VAR_QT")		ms =	MS_VAR_QT;
	if(tmp=="MU")			ms =	MS_VAR_MU;
	if(tmp=="QT")			ms =	MS_VAR_QT;
	if(tmp=="CONST_MU_PI2")		ms =	MS_CONST_MU_PI2;
	if(tmp=="CONST_QT_PI2")		ms =	MS_CONST_QT_PI2;
	if(tmp=="VAR_MU_PI2")		ms =	MS_VAR_MU_PI2;
	if(tmp=="VAR_QT_PI2")		ms =	MS_VAR_QT_PI2;
	if(ms==MS_WRONG) throw bad_in_exception(tmp);
	return is;
}

istream& CuTe::NS_enums::NS_COL::operator>>( istream& is, COL& col ){
	string tmp;
	is >> tmp;
	col	= COL_WRONG;
	if(tmp=="PP")		col	= COL_PP;
	if(tmp=="PPbar")	col	= COL_PbarP;
	if(tmp=="PbarPbar")	col	= COL_PbarPbar;
	if(col==COL_WRONG) throw bad_in_exception(tmp);
	return is;
}

istream& CuTe::NS_enums::NS_RES::operator>>( istream& is, RES& res ){
	string tmp;
	is >> tmp;
	res = RES_WRONG_STATEMENT;
	if(tmp=="RES")		res	= RES_LL;
	if(tmp=="SQT")		res	= RES_LLO;
	if(tmp=="FO")		res	= RES_LO;
	if(tmp=="MATCHED")	res	= RES_MATCHED;
	if(tmp=="MC")		res	= RES_MATCHING_CORR;
	if(tmp=="RC")		res	= RES_RES_CORR;
	if(res==RES_WRONG_STATEMENT) throw bad_in_exception(tmp);
	return is;
}
//istream& CuTe::NS_enums::operator>>( istream& is, PDF_ERR& err){
//	string tmp;
//	is >> tmp;
//	err	= PDF_ERR_WRONG_STATEMENT;
//	if(tmp=="NO")		err = PDF_ERR_NO;
//	if(tmp=="HESSIAN")	err = PDF_ERR_HESSIAN;
//	if(tmp=="GAUSSIAN")	err = PDF_ERR_GAUSSIAN;
//	if(err==PDF_ERR_WRONG_STATEMENT) throw bad_in_exception(tmp);
//	return is;
//}
istream& CuTe::NS_enums::NS_NP::operator>>( istream& is, CUTOFF& cutoff){
	string tmp;
	is >> tmp;
	cutoff = CUTOFF_WRONG;
	if(tmp=="NO")		cutoff = CUTOFF_NO;
	if(tmp=="GAUSS")	cutoff = CUTOFF_GAUSS;
	if(tmp=="DIPOLE")	cutoff = CUTOFF_DIPOL;
	if(tmp=="ENHANCED")	cutoff = CUTOFF_ENHANCED;
	if(cutoff==CUTOFF_WRONG) throw bad_in_exception(tmp);
	return is;
}
istream& CuTe::NS_enums::NS_PROD::operator>>( istream& is, PROD& prod){
	string tmp;
	is >> tmp;
	prod = PROD_WRONG_STATEMENT;
	if(tmp=="DY") 		prod = PROD_DY;
	if(tmp=="Z") 		prod = PROD_Z;
	if(tmp=="W") 		prod = PROD_W;
	if(tmp=="H") 		prod = PROD_Higgs;
	if(tmp=="H_RS") 	prod = PROD_H_RS;
	if(prod==PROD_WRONG_STATEMENT) throw bad_in_exception(tmp);
	return is;
}
istream& CuTe::NS_enums::NS_CUBA::operator>>( istream& is, CUBA_R& cr){
	string tmp;
	is >> tmp;
	cr = CUBA_R_WRONG;
	if(tmp=="VEGAS") 	cr = CUBA_R_VEGAS;
	if(tmp=="SUAVE") 	cr = CUBA_R_SUAVE;
	if(tmp=="DIVONNE") 	cr = CUBA_R_DIVONNE;
	if(tmp=="CUHRE") 	cr = CUBA_R_CUHRE;
	if(cr==CUBA_R_WRONG) throw bad_in_exception(tmp);
	return is;
}
//istream& CuTe::NS_enums::operator>>( istream& is, LHA_ERROR_TYPE& et){
//	string tmp;
//	is >> tmp;
////	cout	<<"operator(is,"<<tmp<<")"<<endl;
//	et = LHA_ERR_wrong;
//	if(tmp=="replicas")		et = LHA_ERR_replicas;
//	if(tmp=="symmhessian") 	et = LHA_ERR_symmhessian;
//	if(tmp=="hessian") 		et = LHA_ERR_hessian;
//	if(tmp=="none") 		et = LHA_ERR_none;
//	if(tmp=="UNKNOWN") 		et = LHA_ERR_UNKNOWN;
//	if(tmp=="unknown") 		et = LHA_ERR_UNKNOWN;
//	if(tmp=="custom") 		et = LHA_ERR_custom;
//	if(et==LHA_ERR_wrong) throw bad_in_exception(tmp);
//	return is;
//}


std::ostream& CuTe::NS_enums::NS_Partons::operator<<(std::ostream& os, const Parton& q){
	switch (q.lha()) {
		case -6:
			os << "bar(t)";
			break;
		case -5:
			os << "bar(b)";
			break;
		case -4:
			os << "bar(c)";
			break;
		case -3:
			os << "bar(s)";
			break;
		case -2:
			os << "bar(u)";
			break;
		case -1:
			os << "bar(d)";
			break;
		case 0:
			os << "G";
			break;
		case 1:
			os << "d";
			break;
		case 2:
			os << "u";
			break;
		case 3:
			os << "s";
			break;
		case 4:
			os << "c";
			break;
		case 5:
			os << "b";
			break;
		case 6:
			os << "t";
			break;
		default:
			os << "!!WRONG FLAVOUR!!";
			break;
	}
	return os;
}

std::ostream& CuTe::NS_enums::NS_Transition_Function::operator<<(std::ostream& os, const ENUM_Transition_Function_Type type){
	switch (type) {
		case TFT_NO:
			os<<"NO";
			break;
		case TFT_LOG:
			os<<"LOG";
			break;
		case TFT_ERF:
			os<<"ERF";
			break;
		case TFT_GPZ:
			os<<"GPZ";
			break;
		case TFT_MGPZ:
			os<<"MGPZ";
			break;
		case TFT_WRONG:
		default:
			os<<"WRONG";
			break;
	}
	return os;
}

std::ostream& CuTe::NS_enums::NS_Transition_Function::operator<<(std::ostream& os, const ENUM_Transition_Function_Arg arg){
	switch (arg) {
		case TFA_ETA:
			os<<"ETA";
			break;
		case TFA_LAMBDA:
			os<<"LAMBDA";
			break;
		case TFA_LAMBDA2:
			os<<"LAMBDA2";
			break;
		case TFA_WRONG:
		default:
			os<<"WRONG";
			break;
	}
	return os;
}

std::istream& CuTe::NS_enums::NS_Transition_Function::operator>>(std::istream& is, ENUM_Transition_Function_Type& type ){
	string in;
	is	>> in;
	for(int i(0); i<=static_cast<int>(TFT_LAST); ++i){
		std::stringstream tmp;
		type = static_cast<ENUM_Transition_Function_Type>(i);
		tmp << type;
		if(tmp.str()==in) break;
	}
	if(type==TFT_LAST)	type = TFT_WRONG;
	if(type==TFT_WRONG)	throw bad_in_exception(in);
	return is;
}

std::istream& CuTe::NS_enums::NS_Transition_Function::operator>>(std::istream& is, ENUM_Transition_Function_Arg& arg){
	string in;
	is	>> in;
	for(int i(0); i<=static_cast<int>(TFA_LAST); ++i){
		std::stringstream tmp;
		arg = static_cast<ENUM_Transition_Function_Arg>(i);
		tmp << arg;
		if(tmp.str()==in) break;
	}
	if(arg==TFA_LAST)	arg	= TFA_WRONG;
	if(arg==TFA_WRONG)	throw bad_in_exception(in);
	return is;
}

