#include "options.h"




bool NS_OPTIONS::_Options_Set::_set_defaults_from_Basefile(File_Path& Basefile,const File_Path& above,int depths){
//	cout	<<"Load Basefile["<<depths<<"]:"<<endl
//			<<"\t"<<Basefile<<endl
//			<<"From:"<<endl
//			<<"\t"<<above<<endl<<endl;
	if(depths>10){
		cerr	<<"Too much Basefiles > 10"<<endl;
		return false;
	}
	bool OK = true;
	ConfigFile base_config;

	if(Basefile.path_sort==NS_File_Path::e_file){
//		cout	<<"base:"<<Basefile.properties()<<endl
//				<<"above:"<<above.properties()<<endl;
		Basefile = File_Path(above,Basefile);
//		cout	<<"=> base:"<<Basefile.properties()<<endl;
	}else{
		if(Basefile.path_sort==NS_File_Path::e_var){
//			cout	<<"base:"<<Basefile.properties()<<endl
//					<<"above:"<<above.properties()<<endl;
			Basefile	= File_Path(above.dir + "/" + Basefile.dir, Basefile.file);
//			cout	<<"=> base:"<<Basefile.properties()<<endl;
		}

	}

	try {
//		cout	<<"Open Basefile["<<depths<<"]= "<<Basefile<<endl;
		base_config = ConfigFile(Basefile);
	} catch (const file_not_found_exception& e) {
		cerr << "File " << e.what() << " not found" << endl;
		OK = false;
	}

	if(OK){
		OK = _read(base_config,Basefile,e_to_def,depths);
	}

	return OK;
}

bool NS_OPTIONS::_Options_Set::_read(ConfigFile& config,const File_Path& fp, e_read to_which, int depths){
	bool OK = true;


	Option<File_Path> base(Basefile);

	if(to_which==e_to_val){
		Basefile.read(config,e_to_val);
		base = Basefile;
	}else{
		base.read(config,e_to_val);
	}

//	cout	<<"fp.properties():"<<endl<<fp.properties()<<endl;
//	cout	<<"base().properties():"<<endl<<base().properties()<<endl;
//	cout	<<"Basefile().properties():"<<endl<<Basefile().properties()<<endl;

	if(base.is_set)	OK = _set_defaults_from_Basefile(base.value,fp,depths+1);


//	if(depths)
//		cout	<<"Read Basefile["<<depths<<"]= "<<fp<<endl;
//	else
//		cout	<<"Read Infile\t= "<<fp<<endl;



	if(OK){
		std::vector<_Option_Interface*>::const_iterator it(options.begin());
		std::vector<_Option_Interface*>::const_iterator end(options.end());

		while(++it!=end){//exclude first=Basefile
			(*(it))->read(config,to_which);
		}

	}

	return OK;
}

bool NS_OPTIONS::_Options_Set::open(const string& filename){
	infilename = filename;

	bool OK = true;
	ConfigFile config;
	try {
//		cout	<<"Open Infile\t= "<<infilename<<endl;
		config = ConfigFile(infilename);
	} catch (const file_not_found_exception& e) {
		cerr << "File " << e.what() << " not found" << endl;
		OK = false;
	}

	if(OK) {
		try {
			OK = _read(config,infilename,e_to_val);
		} catch (const key_not_found_exception& e) {
			cerr << "**** Parameter \"";
			int tmp_w=cerr.width();
			cerr.width(name_width);
			cerr << e.what();
			cerr.width(tmp_w);
			cerr << "\" not found: No default Value " << endl;
			OK=false;
		} catch (const bad_in_exception& e) {
			cerr << "**** " << e.what() << endl;
			OK=false;
		}
	}
	// Process

	return OK;
}


std::stringstream& NS_OPTIONS::_Options_Set::to_ss(std::stringstream& ss, const std::string pre)const{

	ss	<<pre<<"#--------- "<<OP_Set_Name<<" -----------"	<<endl;
	// start @ 1 to exclude Basefile
	for (uint i = 1; i < options.size(); ++i){
		ss	<<pre;
		options[i]->to_stream(ss);
		ss	<<endl;
	}
	ss	<<pre<<endl;

	return ss;
}

std::ostream& NS_OPTIONS::_Options_Set::into_stream(std::ostream& os, const std::string pre)const{
	stringstream ss;
	to_ss(ss,pre);
	os	<< ss.str();

	return os;
}

const std::string NS_OPTIONS::_Options_Set::properties()const{
	stringstream ss;

	for(int i=0; i<options.size(); ++i){
		(*(options[i])).properties(ss)	<<endl	<<endl;
	}

	return ss.str();
}

std::ostream& operator<<(std::ostream& os, const NS_OPTIONS::_Options_Set& op){
	op.into_stream(os);
	return os;
}


std::ostream& operator<<(std::ostream& os, const NS_OPTIONS::_Set_of_Options_Sets& ops){
	ops.into_stream(os);
	return os;
}

std::ostream& NS_OPTIONS::operator<<(std::ostream& os, const NS_OPTIONS::_Set_of_Options_Sets& op){
	return op.into_stream(os);
}
